//*********************************************************
// MAIN.cpp                                    11/08/99
//*********************************************************
#include <math.h>
#include <stdio.h>
#include <stdlib.h>
#include <conio.h>
#include <dos.h>
#include <string.h>
#include <bios.h>

#include "mstep3.h"
//----- define ------------------------------------------
#define CARD1 0
#define CARD2 1

#define COM_BACK       BLUE
#define COM_TEXT       WHITE
#define COM_UP_BACK    WHITE
#define COM_UP_TEXT    BLACK+BLINK
#define COM_ON_BACK    RED
#define COM_ON_TEXT    WHITE
#define SYS_ON_BACK    MAGENTA
#define SYS_ON_TEXT    WHITE
#define SYS_OFF_BACK   CYAN
#define SYS_OFF_TEXT   WHITE
#define SCREEN	       WHITE
#define SCREEN_BACK    BLUE

#define CHANGE_MODE    0
#define TEST_DO        1
#define STOP_X         2
#define STOP_Y         3
#define STOP_Z         4
#define STOP_ALL       5
#define RESET_SYSTEM   6
#define BACK_HOME      7
#define BACK_HOME01    8
#define PULSE_MOVE     9
#define INTP_PULSE     10
#define INTP_LINE      11
#define INTP_LINE02    12
#define INTP_CIRCLE    13
#define INTP_CIRCLE02  14
#define INTP_ARC       15
#define INTP_ARC02     16
#define INTP_XYZ02     17
#define CONSTANT_SPEED 18
#define DEC_STOP       19
#define MULTI_TEST     20

//----- structure ---------------------------------------
typedef struct
  {
	 //---- parameter ---------
	 unsigned int  address;
	 unsigned char exist;
	 unsigned char DDA;
	 unsigned char AD;
	 unsigned int  LSP;
	 unsigned int  HSP;
	 unsigned char home_speed;
	 unsigned char search_speed;
	 unsigned int  arc_speed;

	 unsigned char x_mode;
	 unsigned char x_dir;
	 unsigned char x_son;

	 unsigned char y_mode;
	 unsigned char y_dir;
	 unsigned char y_son;

	 unsigned char z_mode;
	 unsigned char z_dir;
	 unsigned char z_son;

	 //---- information -------
	 unsigned char op;
	 unsigned char ip;
	 unsigned char msc;
	 unsigned char ls;
	 unsigned char p1;
	 unsigned char x_state;
 	 unsigned char y_state;
	 unsigned char z_state;
	 long          XC;
	 long          XP;
	 long          YC;
	 long          YP;
	 long          ZC;
	 long          ZP;
  }CardParameter;

typedef char string30[30];
typedef struct
	{
	  int	   max;
	  string30  name[30];
	  int	   x[30],y[30];
	} menutype;

//----- variable ----------------------------------------
menutype      menu;
CardParameter card1,card2;
char	      screen_buffer[4096];

//####################################################################
//####################################################################
#define INTR 0x08
#define sampling_time 11931          // <1193180Hz>/11931=Hz(10ms)
unsigned long sampling_counter1=0;

void interrupt sampling_ISR(...);
void interrupt (*old_handler)(...);


void show_information();
void lamp_L(unsigned char lswitch,
	    unsigned char x,
	    unsigned char y,
	    char show_text[10]);
void lamp_H(unsigned char lswitch,
	    unsigned char x,
	    unsigned char y,
	    char show_text[10]);
//--------------------------------------------------------------------
void set_timer()
{
  disable();
	  old_handler = getvect(INTR);
	  setvect(INTR, sampling_ISR);
	  outp(0x43, 0x34);
	  outp(0x40,  sampling_time & 0x00ff);
	  outp(0x40, (sampling_time >> 8) );
  outportb(0x20,0x20);
  enable();
}
//--------------------------------------------------------------------
void release_timer()
{
  disable();
	 outp(0x43, 0x34);
	 outp(0x40, 0x00);
	 outp(0x40, 0x00);
	 setvect(INTR, old_handler);
	 outportb(0x20,0x20);
  enable();
}
//--------------------------------------------------------------------
void interrupt sampling_ISR(...)    // 10ms sample once
{
int cx,cy,chkey;

  cx=wherex();
  cy=wherey();
  _setcursortype(_NOCURSOR);
  disable();

  sampling_counter1 += sampling_time;
  if (sampling_counter1>65536L)
  {
	 sampling_counter1-=65536L;
	 old_handler();             // trigger original 0x08h (18.Hz)
  };

  //----- check F7 ------------------------------
  if ((chkey=bioskey(1))!=0)  //don't get key
    if (chkey==0x4100)
    {
      bioskey(0); //get key
      MSTEP3_EMG_STOP(CARD1);
    }
  //----- get card 1 information ----------------
  if (card1.exist==YES)
  {
    card1.ip  = MSTEP3_DI(CARD1);
    card1.msc = MSTEP3_MSC(CARD1);

    MSTEP3_GET_CARD(CARD1);
    card1.ls  =MSTEP3_GET_LIMIT(CARD1);
    card1.p1  =MSTEP3_GET_P1(CARD1);
    card1.XC  =MSTEP3_GET_XC(CARD1);
    card1.XP  =MSTEP3_GET_XP(CARD1);
    card1.YC  =MSTEP3_GET_YC(CARD1);
    card1.YP  =MSTEP3_GET_YP(CARD1);
    card1.ZC  =MSTEP3_GET_ZC(CARD1);
    card1.ZP  =MSTEP3_GET_ZP(CARD1);
  }

  show_information();
  textbackground(SYS_OFF_BACK);
  textcolor(SYS_OFF_TEXT);
  gotoxy(cx,cy);
  _setcursortype(_NORMALCURSOR);
  outportb(0x20,0x20);
  enable();
}
//####################################################################
//--------------------------------------------------------------------
void lamp_L(unsigned char lswitch,
				unsigned char x,
				unsigned char y,
				char show_text[10])
{
  if (lswitch!=0)
  {
	textbackground(SYS_OFF_BACK);
	textcolor(SYS_OFF_TEXT);
  }
  else
  {
	textbackground(SYS_ON_BACK);
	textcolor(SYS_ON_TEXT);
  }
  gotoxy(x,y);
  cprintf(show_text);

}

void lamp_H(unsigned char lswitch,
				unsigned char x,
				unsigned char y,
				char     show_text[10])
{
  if (lswitch==0)
  {
	textbackground(SYS_OFF_BACK);
	textcolor(SYS_OFF_TEXT);
  }
  else
  {
	textbackground(SYS_ON_BACK);
	textcolor(SYS_ON_TEXT);
  }
  gotoxy(x,y);
  cprintf(show_text);
}
//-------------------------------------------------------------------
void show_information()
{
char str[20];

  lamp_L(card1.ip & 0x01,1,3, "/IP1");
  lamp_L(card1.ip & 0x02,1,4, "/IP2");
  lamp_L(card1.ip & 0x04,1,5, "/IP3");
  lamp_L(card1.ip & 0x08,1,6, "/IP4");
  lamp_L(card1.ip & 0x10,1,7, "/IP5");
  lamp_L(card1.ip & 0x20,1,8, "/IP6");
  lamp_L(card1.ip & 0x40,1,9, "/IP7");
  lamp_L(card1.ip & 0x80,1,10,"/IP8");

  lamp_H(card1.op & 0x01,6,3, "OP1");
  lamp_H(card1.op & 0x02,6,4, "OP2");
  lamp_H(card1.op & 0x04,6,5, "OP3");
  lamp_H(card1.op & 0x08,6,6, "OP4");
  lamp_H(card1.op & 0x10,6,7, "OP5");
  lamp_H(card1.op & 0x20,6,8, "OP6");
  lamp_H(card1.op & 0x40,6,9, "OP7");

  lamp_L(card1.msc & 0x01,10,3, "/F1E");
  lamp_L(card1.msc & 0x02,10,4, "/F1F");
  lamp_L(card1.msc & 0x04,10,5, "/F2E");
  lamp_L(card1.msc & 0x08,10,6, "/F2H");
  lamp_L(card1.msc & 0x10,10,7, "/Xsp");
  lamp_L(card1.msc & 0x20,10,8, "/Ysp");
  lamp_L(card1.msc & 0x40,10,9, "/Zsp");
  lamp_L(card1.msc & 0x80,10,10,"/EMG");

  lamp_L(card1.ls & 0x01,15,3, "/XL+");
  lamp_L(card1.ls & 0x02,15,4, "/XL-");
  lamp_L(card1.ls & 0x04,15,5, "/YL+");
  lamp_L(card1.ls & 0x08,15,6, "/YL-");
  lamp_L(card1.ls & 0x10,15,7, "/ZL+");
  lamp_L(card1.ls & 0x20,15,8, "/ZL-");
  lamp_L(card1.ls & 0x40,15,9, "/EMG");

  lamp_L(card1.p1 & 0x02,20,4, "/XI");
  lamp_L(card1.p1 & 0x04,20,5, "/YI");
  lamp_L(card1.p1 & 0x08,20,6, "/ZI");
  lamp_H(card1.p1 & 0x10,20,7, "C1 ");
  lamp_H(card1.p1 & 0x20,20,8, "C2 ");
  lamp_H(card1.p1 & 0x40,20,9, "C3 ");

  //-------------------------------------
  textbackground(SYS_OFF_BACK);
  textcolor(SYS_OFF_TEXT);

  ltoa( card1.XC, str, 10);
  gotoxy(6,23); cprintf("        ");
  gotoxy(6,23); cprintf(str);
  ltoa( card1.XP, str, 10);
  gotoxy(18,23); cprintf("        ");
  gotoxy(18,23); cprintf(str);

  ltoa( card1.YC, str, 10);
  gotoxy(6,24); cprintf("        ");
  gotoxy(6,24); cprintf(str);
  ltoa( card1.YP, str, 10);
  gotoxy(18,24); cprintf("        ");
  gotoxy(18,24); cprintf(str);

  ltoa( card1.ZC, str, 10);
  gotoxy(6,25); cprintf("        ");
  gotoxy(6,25); cprintf(str);
  ltoa( card1.ZP, str, 10);
  gotoxy(18,25); cprintf("        ");
  gotoxy(18,25); cprintf(str);
}
//####################################################################
//####################################################################
void unpressed_text(unsigned char x, unsigned char y,
		    string30 show_text)
{
  textbackground(COM_BACK);
  textcolor(COM_TEXT);
  gotoxy(x,y);
  cprintf(show_text);
  gotoxy(x,y);
}
//----------------------------------------------------------
void pressed_text(unsigned char x, unsigned char y,
			 string30 show_text)
{
  textbackground(COM_UP_BACK);
  textcolor(COM_UP_TEXT);
  gotoxy(x,y);
  cprintf(show_text);
  gotoxy(x,y);
}
//----------------------------------------------------------
void work_text(unsigned char x, unsigned char y,
			 string30 show_text)
{
  textbackground(COM_ON_BACK);
  textcolor(COM_ON_TEXT);
  gotoxy(x,y);
  cprintf(show_text);
  gotoxy(x,y);
}
//---------------------------------------------------------
void show_control_mode()
{
	lamp_H(card1.x_son  & 0x01,22,14, "SON");
	lamp_H(card1.x_mode & 0x04,26,14, "EN");
	lamp_H(card1.x_mode & 0x08,26,15, "OE");
	lamp_H(card1.x_mode & 0x40,22,15, "EXT");
	textbackground(SYS_ON_BACK);
	textcolor(SYS_ON_TEXT);
	gotoxy(15,14);
	if ((card1.x_mode & 0x01)==DDA_CW_CCW) cprintf("CW/CCW");
	else                                   cprintf("DIR/P ");
	gotoxy(15,15);
	if      ((card1.x_mode & 0x30)==ENC_AB_PHASE) cprintf("AB_P  ");
	else if ((card1.x_mode & 0x30)==ENC_CW_CCW)   cprintf("CW/CCW");
	else                                          cprintf("DIR/P ");
	textbackground(SYS_OFF_BACK);
	textcolor(SYS_OFF_TEXT);
	gotoxy(15,13); cprintf("X dir=");
	gotoxy(21,13);
	if (card1.x_dir==NORMAL_DIR) cprintf("NORMAL");
	else                         cprintf("REVERSE");

	lamp_H(card1.y_son  & 0x01,22,17, "SON");
	lamp_H(card1.y_mode & 0x04,26,17, "EN");
	lamp_H(card1.y_mode & 0x08,26,18, "OE");
	lamp_H(card1.y_mode & 0x40,22,18, "EXT");
	textbackground(SYS_ON_BACK);
	textcolor(SYS_ON_TEXT);
	gotoxy(15,17);
	if ((card1.y_mode & 0x01)==DDA_CW_CCW) cprintf("CW/CCW");
	else                                   cprintf("DIR/P ");
	gotoxy(15,18);
	if      ((card1.y_mode & 0x30)==ENC_AB_PHASE) cprintf("AB_P  ");
	else if ((card1.y_mode & 0x30)==ENC_CW_CCW)   cprintf("CW/CCW");
	else                                          cprintf("DIR/P ");
	textbackground(SYS_OFF_BACK);
	textcolor(SYS_OFF_TEXT);
	gotoxy(15,16); cprintf("Y dir=");
	gotoxy(21,16);
	if (card1.y_dir==NORMAL_DIR) cprintf("NORMAL");
	else                         cprintf("REVERSE");

	lamp_H(card1.z_son  & 0x01,22,20, "SON");
	lamp_H(card1.z_mode & 0x04,26,20, "EN");
	lamp_H(card1.z_mode & 0x08,26,21, "OE");
	lamp_H(card1.z_mode & 0x40,22,21, "EXT");
	textbackground(SYS_ON_BACK);
	textcolor(SYS_ON_TEXT);
	gotoxy(15,20);
	if ((card1.z_mode & 0x01)==DDA_CW_CCW) cprintf("CW/CCW");
	else                                   cprintf("DIR/P ");
	gotoxy(15,21);
	if      ((card1.z_mode & 0x30)==ENC_AB_PHASE) cprintf("AB_P  ");
	else if ((card1.z_mode & 0x30)==ENC_CW_CCW)   cprintf("CW/CCW");
	else                                          cprintf("DIR/P ");
	textbackground(SYS_OFF_BACK);
	textcolor(SYS_OFF_TEXT);
	gotoxy(15,19); cprintf("Z dir=");
	gotoxy(21,19);
	if (card1.z_dir==NORMAL_DIR) cprintf("NORMAL");
	else                         cprintf("REVERSE");
}
//---------------------------------------------------------
void init_system_display()
{
int i;
	//---- print title ------
	textbackground(SYS_ON_BACK);
	textcolor(SYS_ON_TEXT);
	gotoxy(1,1);
	cprintf(
"    PISO-PS300 3-axis Stepping/Servo Control Card   version 1.0        12/15/99");

	window(1,2,27,25);
	textbackground(SYS_OFF_BACK);
	textcolor(SYS_OFF_TEXT);
	clrscr();
	//-------- show pannel
	window(1,1,80,25);
	textbackground(SYS_ON_BACK);
	textcolor(SYS_ON_TEXT);
	gotoxy(1,2);   cprintf("     I/O Information       ");
	gotoxy(1,11);   cprintf("      Motion Parameter     ");

	menu.max=21;
	for (i=0; i<12; i++)
	{
		menu.x[i]=30;
		menu.y[i]=2+i*2;
	}
	for (i=12; i<24; i++)
	{
		menu.x[i]=55;
		menu.y[i]=2+(i-12)*2;
	}

	strcpy(menu.name[0], " Simulation/Real mode ");
	strcpy(menu.name[1], " test DO              ");
	strcpy(menu.name[2], " MSTEP3_STOP_X        ");
	strcpy(menu.name[3], " MSTEP3_STOP_Y        ");
	strcpy(menu.name[4], " MSTEP3_STOP_Z        ");
	strcpy(menu.name[5], " MSTEP3_STOP_ALL      ");
	strcpy(menu.name[6], " MSTEP3_RESET_SYSTEM  ");
	strcpy(menu.name[7], " MSTEP3_BACK_HOME     ");
	strcpy(menu.name[8], " MSTEP3_BACK_HOME01   ");
	strcpy(menu.name[9], " MSTEP3_PULSE_MOVE    ");
	strcpy(menu.name[10]," MSTEP3_INTP_PULSE    ");
	strcpy(menu.name[11]," MSTEP3_INTP_LINE     ");
	strcpy(menu.name[12]," MSTEP3_INTP_LINE02   ");
	strcpy(menu.name[13]," MSTEP3_INTP_CIRCLE   ");
	strcpy(menu.name[14]," MSTEP3_INTP_CIRCLE02 ");
	strcpy(menu.name[15]," MSTEP3_INTP_ARC      ");
	strcpy(menu.name[16]," MSTEP3_INTP_ARC02    ");
	strcpy(menu.name[17]," MSTEP3_INTP_XYZ02    ");
	strcpy(menu.name[18]," MSTEP3_CONSTANT_SPEED");
	strcpy(menu.name[19]," MSTEP3_DEC_STOP      ");
	strcpy(menu.name[20]," Multi testing        ");

	for (i=0; i<menu.max; i++)
	  unpressed_text (menu.x[i], menu.y[i], menu.name[i]);

	textbackground(SYS_OFF_BACK);
	textcolor(SYS_OFF_TEXT);
	gotoxy(1,12); cprintf("card1 exist =");
	gotoxy(15,12);
	if (card1.exist==YES) cprintf("YES");
	else                  cprintf("NO");

	gotoxy(1,13); cprintf("Address=%d",card1.address);
	gotoxy(1,14); cprintf("DDA    =%d",card1.DDA);
	gotoxy(1,15); cprintf("AD     =%d",card1.AD);
	gotoxy(1,16); cprintf("LSP    =%d",card1.LSP);
	gotoxy(1,17); cprintf("HSP    =%d",card1.HSP);
	gotoxy(1,18); cprintf("HomSpd =%d",card1.home_speed);
	gotoxy(1,19); cprintf("SchSpd =%d",card1.search_speed);
	gotoxy(1,20); cprintf("ArcSpd =%d",card1.arc_speed);

	show_control_mode();

	gotoxy(2,23);  cprintf("XC=");
	gotoxy(14,23); cprintf("XP=");
	gotoxy(2,24);  cprintf("YC=");
	gotoxy(14,24); cprintf("YP=");
	gotoxy(2,25);  cprintf("ZC=");
	gotoxy(14,25); cprintf("ZP=");
}

//#############################################################
char *input_string(int x, int y, int max, char istr[30], int fch)
{
	int	 l,c,j;
	int	ch,ch1;

	l=strlen(istr);
	c=l;
	if (c>=max) c=max-1;
	ch=fch;
	disable();
	textbackground(BLACK); textcolor(WHITE);
	gotoxy(x,y); for (j=0; j<max; j++) cprintf(" ");
	gotoxy(x,y); cprintf(istr);
	gotoxy(x+c,y);
	enable();
  do {
	 switch (ch) {
	 case 0x4b00: c--; if (c<0) c=0;	    /* left */
		 break;
	 case 0x4d00: c++; if (c>l) c=l;   /* right */
				if (c>max-1) c=max-1;
		 break;
	 case 0x5300: if (l>0)		    /* del */
			{
			  for (j=c; j<l; j++) istr[j]=istr[j+1];
			  istr[j]='\0'; l=strlen(istr);
			}
		 break;
	 case 0x0e08: c--;			    /* backspace */
		 if (c<0) c=0;
		 else
			{
			  for (j=c; j<l; j++) istr[j]=istr[j+1];
			  istr[j]='\0'; l=strlen(istr);
			}
		 break;

	 default: ch1=ch&0x00ff;
		  if ((ch1>12)&(ch1<122))
		  {
			 if ( c>=strlen(istr))
		  {
		  istr[c]=ch1; istr[c+1]='\0'; c++;
		  }
			 else { istr[c]=ch1; c++;};

			 if (c>max-1) c=max-1;
		  }

		  break;
		 }
	  disable();
	  l=strlen(istr);
	  textbackground(0); textcolor(7);
	  gotoxy(x,y); for (j=0; j<max; j++) cprintf(" ");
	  textbackground(0); textcolor(7);
	  gotoxy(x,y); cprintf(istr);
	  gotoxy(x+c,y);
     enable();
	  do {
	} while (!bioskey(1));
	ch=bioskey(0);

	 } while (ch!=0x1c0d);
	 return (istr);
}
//----------------------------------------------------------------
long get_number(string30 show_text)
{
string30 tstr;
long temp;
  disable();
  gettext(20,11,60,13,screen_buffer);
  textbackground(WHITE);
  textcolor(BLACK);
  window(20,11,60,13);
  clrscr();
  window(1,1,80,25);
  gotoxy(20,11); cprintf("ͻ");
  gotoxy(20,12); cprintf("                                       ");
  gotoxy(20,13); cprintf("ͼ");

  gotoxy(22,12);
  cprintf(show_text);
  enable();
  strcpy(tstr,"");
  temp = atol(input_string(wherex(),wherey(),8,tstr,0) );

  window(1,1,80,25);
  puttext(20,11,60,13,screen_buffer);
  return temp;
}
//---------------------------------------------------------------------
void MessageBox(string30 show_text)
{               
  disable();
  gettext(40,11,80,13,screen_buffer);
  textbackground(WHITE);
  textcolor(BLACK);
  window(40,11,80,13);
  clrscr();
  window(1,1,80,25);
  gotoxy(40,11); cprintf("ͻ");
  gotoxy(40,12); cprintf("                                       ");
  gotoxy(40,13); cprintf("ͼ");

  gotoxy(42,12);
  cprintf(show_text);
  enable();

  do { delay(10); } while (!kbhit());
  bioskey(0);
  window(1,1,80,25);
  puttext(40,11,80,13,screen_buffer);
}
//--------------------------------------------------------------------
void set_parameter()
{
  MSTEP3_SET_NC(CARD1,NO);
  //MSTEP3_SET_NC(CARD1,0x01);
  //MSTEP3_SET_NC(CARD1,0x02|0x04|0x10);
  MSTEP3_SET_CONTROL_MODE(CARD1, card1.x_mode, card1.y_mode, card1.z_mode);
  MSTEP3_SET_VAR(CARD1, card1.DDA, card1.AD, card1.LSP,
		 card1.HSP, card1.arc_speed);
  MSTEP3_SET_DEFDIR(CARD1, card1.x_dir, card1.y_dir, card1.z_dir);
  MSTEP3_SET_SERVO_ON(CARD1, card1.x_son, card1.y_son, card1.z_son);
}
//####################################################################
void operation(unsigned char command)
{
unsigned char j,temp;
unsigned char axis,dir,mode,plane;
unsigned int  speed;
long	      pulse;
int	      pulsex,pulsey,pulsez;
long	      x,y,z,R;

 switch (command)
 {
  case CHANGE_MODE:
		mode=(unsigned char) get_number("Mode 1(simu.)2(real)= ");
		if (mode==1)
		 {
		   card1.x_mode = DDA_CW_CCW|DDA_EN|
				  ENC_CW_CCW|ENC_INTERNAL;
		   card1.y_mode = DDA_CW_CCW|DDA_EN|
				  ENC_CW_CCW|ENC_INTERNAL;
		   card1.z_mode = DDA_CW_CCW|DDA_EN|
				  ENC_CW_CCW|ENC_INTERNAL;
		 }
		if (mode==2)
		 {
		   card1.x_mode = DDA_CW_CCW|DDA_EN|DDA_OE|
				  ENC_AB_PHASE|ENC_EXTERNAL;
		   card1.y_mode = DDA_CW_CCW|DDA_EN|DDA_OE|
				  ENC_AB_PHASE|ENC_EXTERNAL;
		   card1.z_mode = DDA_CW_CCW|DDA_EN|DDA_OE|
				  ENC_AB_PHASE|ENC_EXTERNAL;
		 }
		if ((mode==1) || (mode==2))
		{
		   MSTEP3_SET_CONTROL_MODE(CARD1, card1.x_mode,
					   card1.y_mode, card1.z_mode);
		   MSTEP3_SET_ZERO(CARD1,X_axis);
		   MSTEP3_SET_ZERO(CARD1,Y_axis);
		   MSTEP3_SET_ZERO(CARD1,Z_axis);
		   show_control_mode();
		}
		break;
  case TEST_DO: temp=0x01;
		for (j=0; j<8; j++)
		{
		  delay(7000);
		  card1.op=temp<<j;
		  MSTEP3_DO(CARD1,card1.op);
		}
		break;
  case STOP_X :
		MSTEP3_STOP(CARD1, X_axis);
		break;
  case STOP_Y :
		MSTEP3_STOP(CARD1, Y_axis);
		break;
  case STOP_Z :
		MSTEP3_STOP(CARD1, Z_axis);
		break;
  case STOP_ALL :
		MSTEP3_STOP_ALL(CARD1);
		break;
  case RESET_SYSTEM :
		MSTEP3_RESET_SYSTEM(CARD1);
		set_parameter();
		break;

  case BACK_HOME :
                if (    (MSTEP3_IS_X_STOP(CARD1)==NO)
                     || (MSTEP3_IS_Y_STOP(CARD1)==NO)
                     || (MSTEP3_IS_Z_STOP(CARD1)==NO))
                {
                  MessageBox("Inhibit now!"); 
                  break;
                };
                  
		axis=(unsigned char) get_number("Axis 1(X)2(Y)3(Z)= ");
		if ((axis!=1) && (axis!=2) && (axis!=3)) break;
		MSTEP3_BACK_HOME(CARD1,axis,card1.home_speed
				,card1.search_speed);
		break;
  case BACK_HOME01 :
                if (    (MSTEP3_IS_X_STOP(CARD1)==NO)
                     || (MSTEP3_IS_Y_STOP(CARD1)==NO)
                     || (MSTEP3_IS_Z_STOP(CARD1)==NO))
		{
                  MessageBox("Inhibit now!"); 
                  break;
                };
                  
		axis=(unsigned char) get_number("Axis 1(X)2(Y)3(Z)= ");
		if ((axis!=1) && (axis!=2) && (axis!=3)) break;
		MSTEP3_BACK_HOME01(CARD1,axis,card1.home_speed);
		break;
		
  case PULSE_MOVE :
                if (    (MSTEP3_IS_X_STOP(CARD1)==NO)
                     || (MSTEP3_IS_Y_STOP(CARD1)==NO)
                     || (MSTEP3_IS_Z_STOP(CARD1)==NO))
                {
                  MessageBox("Inhibit now!"); 
                  break;
                };
                  
		axis=(unsigned char) get_number("Axis 1(X)2(Y)3(Z)= ");
		pulse=(long) get_number("input pulse (+- 2^31 -1) = ");
		speed=(unsigned int) get_number("speed (<2040)= ");
		if ((axis!=1) && (axis!=2) && (axis!=3)) break;
		MSTEP3_PULSE_MOVE(CARD1,axis,pulse,speed);
		break;
		
  case INTP_PULSE :
                if (    (MSTEP3_IS_X_STOP(CARD1)==NO)
                     || (MSTEP3_IS_Y_STOP(CARD1)==NO)
                     || (MSTEP3_IS_Z_STOP(CARD1)==NO))
                {
                  MessageBox("Inhibit now!"); 
                  break;
                };
                  
		pulsex=(int) get_number("X pulse number (-2047 ~ 2047) = ");
		pulsey=(int) get_number("Y pulse number (-2047 ~ 2047) = ");
		pulsez=(int) get_number("Z pulse number (-2047 ~ 2047) = ");
		if (abs(pulsex) > 2047 ) break;
		if (abs(pulsey) > 2047 ) break;
		if (abs(pulsez) > 2047 ) break;
		MSTEP3_INTP_PULSE(CARD1,pulsex,pulsey,pulsez);
		break;
		
  case INTP_XYZ02:
                if (    (MSTEP3_IS_X_STOP(CARD1)==NO)
                     || (MSTEP3_IS_Y_STOP(CARD1)==NO)
                     || (MSTEP3_IS_Z_STOP(CARD1)==NO))
                {
                  MessageBox("Inhibit now!"); 
                  break;
                };
                  
		x=(long) get_number("X pulse number (+-2^31 -1)= ");
		y=(long) get_number("Y pulse number (+-2^31 -1)= ");
		z=(long) get_number("Z pulse number (+-2^31 -1)= ");
		speed=(unsigned int) get_number("speed (<2040)= ");
		//MSTEP3_INTP_XYZ(CARD1,x,y,z,speed);
		MSTEP3_INTP_XYZ02(CARD1,x,y,z,speed,0); 
		do {} while (MSTEP3_INTP_STOP()!=READY);
		break;
		
  case INTP_LINE :
                if (    (MSTEP3_IS_X_STOP(CARD1)==NO)
                     || (MSTEP3_IS_Y_STOP(CARD1)==NO)
                     || (MSTEP3_IS_Z_STOP(CARD1)==NO))
                {
		  MessageBox("Inhibit now!");
		  break;
		};

		x=(long) get_number("X pulse number (+-2^31 -1)= ");
		y=(long) get_number("Y pulse number (+-2^31 -1)= ");
		speed=(unsigned int) get_number("speed (<2040)= ");
		MSTEP3_INTP_LINE(CARD1,x,y,speed);
		break;

  case INTP_LINE02:
                if (    (MSTEP3_IS_X_STOP(CARD1)==NO)
                     || (MSTEP3_IS_Y_STOP(CARD1)==NO)
		     || (MSTEP3_IS_Z_STOP(CARD1)==NO))
                {
                  MessageBox("Inhibit now!"); 
                  break;
                };
                  
		plane=(unsigned char) get_number("Plane 1(X-Y)2(X-Z)3(Y-Z)= ");

		x=(long) get_number("X pulse number (+-2^31 -1)= ");
		y=(long) get_number("Y pulse number (+-2^31 -1)= ");
		speed=(unsigned int) get_number("speed (<2040)= ");

		MSTEP3_INTP_LINE02(CARD1,plane,x,y,speed,0);
		do {} while (MSTEP3_INTP_STOP()!=READY);
		break;

  case INTP_CIRCLE :
                if (    (MSTEP3_IS_X_STOP(CARD1)==NO)
                     || (MSTEP3_IS_Y_STOP(CARD1)==NO)
                     || (MSTEP3_IS_Z_STOP(CARD1)==NO))
		{
                  MessageBox("Inhibit now!"); 
                  break;
                };
                
		x=(long) get_number("center point X = ");
		y=(long) get_number("center point Y = ");
		dir =(unsigned char) get_number("0: CW/FW    1: CCW/BW = ");
		if ((dir!=CW) && (dir!=CCW)) break;
		speed=(unsigned int) get_number("speed (<2040)= ");
		MSTEP3_INTP_CIRCLE(CARD1,x,y,dir,speed);
		break;
		
  case INTP_CIRCLE02 :
                if (    (MSTEP3_IS_X_STOP(CARD1)==NO)
                     || (MSTEP3_IS_Y_STOP(CARD1)==NO)
                     || (MSTEP3_IS_Z_STOP(CARD1)==NO))
                {
                  MessageBox("Inhibit now!"); 
                  break;
		};
                  
		plane=(unsigned char) get_number("Plane 1(X-Y)2(X-Z)3(Y-Z)= ");
		if ((plane<1) && (plane>3)) break;
		x=(long) get_number("center point X = ");
		y=(long) get_number("center point Y = ");
		dir =(unsigned char) get_number("0: CW/FW    1: CCW/BW = ");
		if ((dir!=CW) && (dir!=CCW)) break;
		speed=(unsigned int) get_number("speed (<2040)= ");

		MSTEP3_INTP_CIRCLE02(CARD1,plane,x,y,dir,speed,0);
		do {} while (MSTEP3_INTP_STOP()!=READY);
		break;

  case INTP_ARC :
                if (    (MSTEP3_IS_X_STOP(CARD1)==NO)
                     || (MSTEP3_IS_Y_STOP(CARD1)==NO)
                     || (MSTEP3_IS_Z_STOP(CARD1)==NO))
                {
                  MessageBox("Inhibit now!"); 
		  break;
                };
                  
		x=(long) get_number("end point X = ");
		y=(long) get_number("end point Y = ");
		R=(long) get_number("Radius (+/-)= ");
		dir =(unsigned char) get_number("0: CW/FW    1: CCW/BW = ");
		if ((dir!=CW) && (dir!=CCW)) break;
		speed=(unsigned int) get_number("speed (<2040)= ");
		MSTEP3_INTP_ARC(CARD1,x,y,R,dir,speed); 
		break;
		
  case INTP_ARC02 :
                if (    (MSTEP3_IS_X_STOP(CARD1)==NO)
		     || (MSTEP3_IS_Y_STOP(CARD1)==NO)
                     || (MSTEP3_IS_Z_STOP(CARD1)==NO))
                {
		  MessageBox("Inhibit now!");
		  break;
		};

		plane=(unsigned char) get_number("Plane 1(X-Y)2(X-Z)3(Y-Z)= ");
		if ((plane<1) && (plane>3)) break;
		x=(long) get_number("end point X = ");
		y=(long) get_number("end point Y = ");
		R=(long) get_number("Radius (+/-)= ");
		dir =(unsigned char) get_number("0: CW/FW    1: CCW/BW = ");
		if ((dir!=CW) && (dir!=CCW)) break;
		speed=(unsigned int) get_number("speed (<2040)= ");

		MSTEP3_INTP_ARC02(CARD1,plane,x,y,R,dir,speed,0);
		do {} while (MSTEP3_INTP_STOP()!=READY);
		break;
  case DEC_STOP:
		axis=(unsigned char) get_number("Axis 1(X)2(Y)3(Z)= ");
		if ((axis!=1) && (axis!=2) && (axis!=3)) break;
		MSTEP3_DEC_STOP(CARD1,axis);
		break;

  case CONSTANT_SPEED :
		axis=(unsigned char) get_number("Axis 1(X)2(Y)3(Z)= ");
		dir =(unsigned char) get_number("0: CW/FW    1: CCW/BW = ");
		speed=(unsigned int) get_number("speed (<2040)= ");
		if ((axis!=1) && (axis!=2) && (axis!=3)) break;
		if ((dir!=CW) && (dir!=CCW)) break;
		MSTEP3_CONSTANT_SPEED(CARD1,axis,dir,speed);
		break;
  case MULTI_TEST :                                      
                if (    (MSTEP3_IS_X_STOP(CARD1)==NO)
                     || (MSTEP3_IS_Y_STOP(CARD1)==NO)
                     || (MSTEP3_IS_Z_STOP(CARD1)==NO))
                {
                  MessageBox("Inhibit now!"); 
                  break;
                };  
		//wait for others interpolation completed
		do {} while (MSTEP3_INTP_STOP()!=READY);

		//test online set speed
		MSTEP3_INTP_XYZ02(CARD1,10000,0,0,20,0);
		do
		{
		  MSTEP3_INTP_ONLINE_SETSPEED( (card1.XC/2000)*10 + 20);
		} while (MSTEP3_INTP_STOP()!=READY);

		//test XYZ01, no acceleration
		MSTEP3_INTP_XYZ02(CARD1,1000,1000,0,20,1);
		do {} while (MSTEP3_INTP_STOP()!=READY);
		MSTEP3_INTP_XYZ02(CARD1,2000,1000,0,22,1);
		do {} while (MSTEP3_INTP_STOP()!=READY);
		MSTEP3_INTP_XYZ02(CARD1,2000,2000,0,24,1);
		do {} while (MSTEP3_INTP_STOP()!=READY);
		MSTEP3_INTP_XYZ02(CARD1,1000,2000,0,26,1);
                do {} while (MSTEP3_INTP_STOP()!=READY);
                
		do {} while (MSTEP3_IS_X_STOP(CARD1)==NO);
		delay(10000);

		//test WAIT_X, WAIT_Y, WAIT_Z
		MSTEP3_INTP_LINE02(CARD1, XY_plane, 10000,-10000,200,0);
		do {} while (MSTEP3_INTP_STOP()!=READY);
		MSTEP3_INTP_LINE02(CARD1, XY_plane, -10000, 10000,200,0);
		do {} while (MSTEP3_INTP_STOP()!=READY);
		MSTEP3_INTP_XYZ02(CARD1, 5000, -10000, -40000, 200, 0);
		do {} while (MSTEP3_INTP_STOP()!=READY);

		do {} while (MSTEP3_IS_X_STOP(CARD1)==NO);
		do {} while (MSTEP3_IS_Y_STOP(CARD1)==NO);
		do {} while (MSTEP3_IS_Z_STOP(CARD1)==NO);
		MSTEP3_STOP_ALL(CARD1);
		delay(10000);

		MSTEP3_INTP_CIRCLE02(CARD1, XY_plane, 5000,-5000, CW, 200, 0);
		do {} while (MSTEP3_INTP_STOP()!=READY);

		do {} while (MSTEP3_IS_X_STOP(CARD1)==NO);
		do {} while (MSTEP3_IS_Y_STOP(CARD1)==NO);
		MSTEP3_STOP_ALL(CARD1);

		break;

  default: break;
 }
}

//###########################################################
//###########################################################
void main()
{
int  j,c,oldc,chkey;
char ch;

  disable();
  clrscr();

  //------set card 1 parameters-------------------------------------
  card1.address      = 0;     //0~15
  card1.DDA          = 10;
  card1.AD           = 5;
  card1.LSP          = 5;
  card1.HSP          = 150;
  card1.home_speed   = 10;
  card1.search_speed = 2;
  card1.arc_speed    = 50;

  card1.x_mode       = DDA_CW_CCW|DDA_EN|DDA_OE|ENC_AB_PHASE|ENC_EXTERNAL;
//  card1.x_mode       = DDA_CW_CCW|DDA_EN|ENC_CW_CCW|ENC_INTERNAL;
//  card1.x_mode       = DDA_DIR_PULSE|DDA_EN|ENC_DIR_PULSE|ENC_INTERNAL;
  card1.x_dir        = NORMAL_DIR;
  card1.x_son        = ON;

  card1.y_mode       = DDA_CW_CCW|DDA_EN|DDA_OE|ENC_AB_PHASE|ENC_EXTERNAL;
//  card1.y_mode       = DDA_CW_CCW|DDA_EN|ENC_CW_CCW|ENC_INTERNAL;
//  card1.y_mode       = DDA_DIR_PULSE|DDA_EN|ENC_DIR_PULSE|ENC_INTERNAL;
  card1.y_dir        = REVERSE_DIR;
  card1.y_son        = ON;

  card1.z_mode       = DDA_CW_CCW|DDA_EN|DDA_OE|ENC_AB_PHASE|ENC_EXTERNAL;
//  card1.z_mode       = DDA_CW_CCW|DDA_EN|ENC_CW_CCW|ENC_INTERNAL;
//  card1.z_mode       = DDA_DIR_PULSE|DDA_EN|ENC_DIR_PULSE|ENC_INTERNAL;
  card1.z_dir        = NORMAL_DIR;
  card1.z_son        = ON;


  //---- check PISO-PS300/S300 is exist or not ------------------------
  card1.exist=MSTEP3_REGISTRATION1(CARD1, card1.address);
  if (card1.exist!=YES)
  {
     cprintf("There is not exist any PISO-PS300/S300 card at:%d !",card1.address);
     return;
  }
  MSTEP3_RESET_SYSTEM(CARD1);
  clrscr();

  //-------------------------------------------------------------------
  set_timer();
  init_system_display();
  //---- setting
  set_parameter();
  enable();

// operation -----------------------------------------
  textbackground(COM_UP_BACK);
  gotoxy(28,25);
  cprintf(" ESC:EXIT F7:STOP  Up,Down:move  Enter:select ");
  c=0; oldc=0;

  pressed_text(menu.x[c], menu.y[c], menu.name[c]);
  do
  {
	 do
	 {
	   //delay(50);
	 } while (!kbhit());
	 chkey=bioskey(0);
	 switch (chkey)
		{
		case 0x4d00 : c +=12;
			 if (c>=menu.max) c -=12;   // right
			 break;
		case 0x4b00 : c -=12;
			 if (c<0)  c +=12;	       // left
			 break;
		case 0x5000 : c++;
			 if ( c>=menu.max ) c=0;    // down
			 break;
		case 0x4800 : c--;
			 if ( c<0 ) c=menu.max-1;   // up
			 break;

		case 0x1c0d : work_text(menu.x[c], menu.y[c], menu.name[c]);
//			 if (card1.exist==YES)
				 operation(c);		// enter
			 pressed_text(menu.x[c], menu.y[c], menu.name[c]);
			 break;
			 //*******************************************************
		case 0x4100:  //F7 STOP ALL
			 MSTEP3_STOP_ALL(CARD1);
			 break;
		default:   break;
		}
	 if (c!=oldc)
	 {
		unpressed_text(menu.x[oldc], menu.y[oldc], menu.name[oldc]);
		pressed_text(menu.x[c], menu.y[c], menu.name[c]);
		oldc=c;
	 };
  } while (chkey!=0x011b); // ESC

 MSTEP3_RESET_SYSTEM(CARD1);
 release_timer();
 textbackground(BLACK);
 clrscr();
 gotoxy(1,25);
}
